#include <stdio.h>
#include <stdbool.h>

#include "common.h"

bool success(int a, int b, int c, int d, int e, int f, int g, int h, int i, int j, int k, int l, int m, int n, int o, int p, char bonus) {
	char buffer[255];
	sprintf(buffer, RESULT_FILE, a, b, c, d);

	FILE *out;
	if (out = fopen(buffer, "a")) {
		sprintf(buffer, RES_LINE, a+b+c+d,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,bonus);

		int res = fputs(buffer, out);
		fclose(out);

		return res >= 0;
	} else return false;
}

bool begin(int a, int b, int c, int d) {
	char buffer[255];
	sprintf(buffer, RESULT_FILE, a, b, c, d);

	return wipe_file(buffer);
}

bool finished(int a, int b, int c, int d) {
	char sourcefile[255];
	sprintf(sourcefile, RESULT_FILE, a, b, c, d);

	char destfile[255];
	sprintf(destfile, FINAL_FILE, a, a, b, c, d);

	return rename(sourcefile, destfile) == 0;
}

bool run_set(int a, int b, int c, int d) {
	char bonus;

	printf("Currently processing set %d, %d, %d, %d!\n", a, b, c, d);

	if (!begin(a, b, c, d)) {
		printf("FATAL INIT ERROR AT %d, %d, %d, %d!\n", a, b, c, d);
		return false;
	}
	int e, f, g, h, i, j, k, l, m, n, o, p;

	for (e=1; e<=16; e++) {
	if ((e != a) && (e != b) && (e != c) && (e != d)) {
	for (f=1; f<=16; f++) {
	if ((f != a) && (f != b) && (f != c) && (f != d) && (f != e)) {
	for (g=1; g<=16; g++) {
	if ((g != a) && (g != b) && (g != c) && (g != d) && (g != e) && (g != f)) {
	for (h=1; h<=16; h++) {
	if ((h != a) && (h != b) && (h != c) && (h != d) && (h != e) && (h != f) && (h != g)) {
	for (i=1; i<=16; i++) {
	if ((i != a) && (i != b) && (i != c) && (i != d) && (i != e) && (i != f) && (i != g) && (i != h)) {
	for (j=1; j<=16; j++) {
	if ((j != a) && (j != b) && (j != c) && (j != d) && (j != e) && (j != f) && (j != g) && (j != h) && (j != i)) {
	for (k=1; k<=16; k++) {
	if ((k != a) && (k != b) && (k != c) && (k != d) && (k != e) && (k != f) && (k != g) && (k != h) && (k != i) && (k != j)) {
	for (l=1; l<=16; l++) {
	if ((l != a) && (l != b) && (l != c) && (l != d) && (l != e) && (l != f) && (l != g) && (l != h) && (l != i) && (l != j) && (l != k)) {
	for (m=1; m<=16; m++) {
	if ((m != a) && (m != b) && (m != c) && (m != d) && (m != e) && (m != f) && (m != g) && (m != h) && (m != i) && (m != j) && (m != k) && (m != l)) {
	for (n=1; n<=16; n++) {
	if ((n != a) && (n != b) && (n != c) && (n != d) && (n != e) && (n != f) && (n != g) && (n != h) && (n != i) && (n != j) && (n != k) && (n != l) && (n != m)) {
	for (o=1; o<=16; o++) {
	if ((o != a) && (o != b) && (o != c) && (o != d) && (o != e) && (o != f) && (o != g) && (o != h) && (o != i) && (o != j) && (o != k) && (o != l) && (o != m) && (o != n)) {
	for (p=1; p<=16; p++) {
	if ((p != a) && (p != b) && (p != c) && (p != d) && (p != e) && (p != f) && (p != g) && (p != h) && (p != i) && (p != j) && (p != k) && (p != l) && (p != m) && (p != n) && (p != o)) {
		int sum = a+b+c+d;
		if (                      (sum == e+f+g+h) && (sum == i+j+k+l) && (sum == m+n+o+p) &&
			 (sum == a+e+i+m) && (sum == b+f+j+n) && (sum == c+g+k+o) && (sum == d+h+l+p) &&
			 (sum == a+f+k+p)) {
			bonus = (sum == m+j+g+d) ? '*' : ' ';
			if (!success(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,bonus)) {
				printf("FATAL SUCCESS ERROR AT %d, %d, %d, %d!\n", a, b, c, d);
				return false;
			}
		}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}
	}

	if (!finished(a, b, c, d)) {
		printf("FATAL FINALIZE ERROR AT %d, %d, %d, %d!\n", a, b, c, d);
		return false;
	}

	return true;
}

bool run_only(int a) {
	char buffer[255];
	int b, c, d;
	int count=0;

	for (b=1; b<=16; b++) {
		if ((b != a)) {
			for (c=1; c<=16; c++) {
				if ((c != a) && (c != b)) {
					for (d=1; d<=16; d++) {
						if ((d != a) && (d != b) && (d != c)) {
							sprintf(buffer, FINAL_FILE, a, a, b, c, d);
							if (!file_exists(buffer)) {
								if (!run_set(a, b, c, d)) return false;
							}
							count++;
							stat(a, count);
						}
					}
				}
			}
		}
	}
	return true;
}

bool run_from(int a) {
	for (; a<=16; a++) {
		if (!run_only(a)) return false;
	}
	return true;
}

bool run_all() {
	return run_from(1);
}

//---------------------------------------------------------------------------
int main(int argc, char* argv[])
{
	if (argc == 2) {
		int a = atoi(argv[1]);
		if ((a < 1) || (a > 16)) {
			printf("Error: Invalid a.\n");
			return 1;
		}
		printf("Run from a=%d...\n", a);
		if (!run_from(a)) return 2;
	} else {
		printf("Run all...\n");
		if (!run_all()) return 2;
	}
	return 0;
}
