<?php

$stat['ViaThinkSoft'] = 'http://home.viathinksoft.de/daniel-marschall/math/4x4/v4/stat/';
$stat['HS Mannheim'] = 'http://jonathan.sv.hs-mannheim.de/~d.marschall/Mathematik/4x4%20Quadrat/v4/stat/';

echo '<h1>4x4 Computing Fortschritt</h1>';

echo '<table border="1" width="50%">';
echo '<tr>';
echo '<td align=right><b>a</b></td>';
foreach ($stat as $name => $staturl) {
	echo '<td align=right><b>'.$name.'</b></td>';
}	
echo '</tr>';

$sum = array();
$sum2 = array();

for ($a=1; $a<=16; $a++) {
	echo '<tr>';
	echo '<td align=right><b>'.$a.'</b></td>';
	foreach ($stat as $name => $staturl) {
		$url = $staturl.'a-'.$a.'.txt';
		$per = getpercent($url);
		$per = trim($per);
		if ($per != '0.000%') {
			echo "<td align=right><b>$per</b></td>";
		} else {
			echo "<td align=right>$per</td>";
		}
		$abs = getabs($url);
		$sum[$name] += $abs;
		if ($abs > $sum2[$a]) $sum2[$a] = $abs;
	}
	echo '</tr>';
}
echo '<tr>';
echo '<td align=right><b>Sum</b></td>';
foreach ($stat as $name => $staturl) {
	$per = $sum[$name]/(16*15*14*13)*100;
	$per = number_format($per, 3, '.', '');
	echo '<td align=right><b>'.($per).'%</b></td>';
}
echo '</tr>';
echo '</table>';

$maxsum = 0;
for ($a=1; $a<=16; $a++) {
	$maxsum += $sum2[$a];
}
$per = $maxsum/(16*15*14*13)*100;
$per = number_format($per, 3, '.', '');
echo '<h2>Gesamt: '.$per.'%</h2>';

function getpercent($url) {
	$cont = file_get_contents($url);
	$ary = explode("\n", $cont);
	$ary = explode("\t", $ary[0]);
	return $ary[5];
}

function getabs($url) {
	$cont = file_get_contents($url);
	$ary = explode("\n", $cont);
	$ary = explode("\t", $ary[0]);
	return $ary[1];
}

?>
